%
% plotscript.m
%
% The matlab script plots the data in the files outl and outr.
% These files must contain the output of the program relaxosc_clncvdemo.cpp.
%

sol1 = load('outl');
sol2 = load('outr');

x = linspace(-2,1,100);

clf
hold on
set(gca,'fontsize',12,'fontweight','bold')
plot(x,x-x.^3/3,'k-')
plot(sol1(:,2),sol1(:,3),'k--','linewidth',3)
plot(sol2(:,2),sol2(:,3),'k-','linewidth',3)

xlabel('x')
ylabel('y')

legend('y = x - x^3/3','Solution 1','Solution 2')
