/*
 *  relaxosc_cv.c
 *
 *  CVODE C file for the vector field named: relaxosc
 *
 *  This file was generated by the program VFGEN (Version:BlueOysterCult:3)
 *  Generated on 28-May-2006 at 22:06
 */

#include <math.h>
#include "sundialstypes.h"
#include "cvode.h"
#include "cvdense.h"
#include "nvector_serial.h"
#include "dense.h"

/*
 *  The vector field.
 */

void relaxosc_vf(realtype t, N_Vector y_, N_Vector f_, void *params)
    {
    realtype x, y;
    realtype epsilon, a;
    realtype *p_;

    p_ = (realtype *) params;

    x          = NV_Ith_S(y_,0);
    y          = NV_Ith_S(y_,1);

    epsilon    = p_[0];
    a          = p_[1];

    NV_Ith_S(f_,0) = 1.0/epsilon*(x-(x*x*x)/3.0-y);
    NV_Ith_S(f_,1) = x-a;
    }

/*
 *  The Jacobian.
 */

void relaxosc_jac(long int N_, DenseMat jac_, realtype t,
                N_Vector y_, N_Vector fy_, void *params,
                N_Vector tmp1, N_Vector tmp2, N_Vector tmp3)
    {
    realtype x, y;
    realtype epsilon, a;
    realtype *p_;

    p_ = (realtype *) params;

    x          = NV_Ith_S(y_,0);
    y          = NV_Ith_S(y_,1);

    epsilon    = p_[0];
    a          = p_[1];

    DENSE_ELEM(jac_, 0, 0) = 1.0/epsilon*(-(x*x)+1.0);
    DENSE_ELEM(jac_, 0, 1) = -1.0*1.0/epsilon;
    DENSE_ELEM(jac_, 1, 0) = 1.0;
    DENSE_ELEM(jac_, 1, 1) = 0.0;
    }
